Print Friendly

# Class Ext.menu.Adapter

Package: | Ext.menu
Class: | Adapter
Extends: | BaseItem
Subclasses: | ColorItem, DateItem
Defined In: | Adapter.js

A base utility class that adapts a non-menu component so that it can be wrapped by a menu item and added to a menu. It provides basic rendering, activation management and enable/disable logic required to work in menus.
Properties - Methods - Events - Config Options

## Public Properties

Property | Defined By
--- | ---
| disabled : Object | Component
true if this component is disabled. Read-only.
| disabledClass : Object | Component
CSS class added to the component when it is disabled.
| hidden : Object | Component
true if this component is hidden. Read-only.
| rendered : Object | Component
true if this component has been rendered. Read-only.

## Public Methods

Method | Defined By
--- | ---
| Adapter(`Object config`) | Adapter
Creates a new Adapter
| addEvents(`Object object`) : void | Observable
Copies any events from the passed object onto this object if they do not already exist. The passed object must also ...
| addListener(`String eventName`, `Function handler`, [`Object scope`], [`Object options`]) : void | Observable
Appends an event handler to this component
| disable() : void | Component
Disable this component
| enable() : void | Component
Enable this component
| fireEvent(`String eventName`, `Object... args`) : Boolean | Observable
Fires the specified event with the passed parameters (minus the event name).
| focus(`Boolean selectText`) : void | Component
Try to focus this component
| getEl() : Ext.Element | Component
Returns the underlying Ext.Element
| getId() : String | Component
Returns the id of this component
| hasListener(`String eventName`) : Boolean | Observable
Checks to see if this object is currently listening for a specified event
| hide() : void | Component
Hide this component
| isVisible() : void | Component
Returns true if this component is visible
| on(`String eventName`, `Function handler`, [`Object options`]) : void | Observable
Appends an event handler to this element (shorthand for addListener)
| purgeListeners() : void | Observable
Removes all listeners for this object
| removeListener(`String eventName`, `Function handler`, [`Object scope`]) : void | Observable
Removes a listener
| render([`String/HTMLElement/Element container`]) : void | Component
If this is a lazy rendering component, render it to its container element
| setDisabled(`Boolean disabled`) : void | Component
Convenience function for setting disabled/enabled by boolean
| setVisible(`Boolean visible`) : void | Component
Convenience function to hide or show this component by boolean
| show() : void | Component
Show this component
| un(`String eventName`, `Function handler`, [`Object scope`]) : void | Observable
Removes a listener (shorthand for removeListener)

## Public Events

Event | Defined By
--- | ---
| activate : (`Ext.menu.BaseItem this`) | BaseItem
Fires when this item is activated
| beforedestroy : (`Ext.Component this`) | Component
Fires before the component is destroyed
| beforehide : (`Ext.Component this`) | Component
Fires before the component is hidden
| beforerender : (`Ext.Component this`) | Component
Fires before the component is rendered
| beforeshow : (`Ext.Component this`) | Component
Fires before the component is shown
| click : (`Ext.menu.BaseItem this`, `Ext.EventObject e`) | BaseItem
Fires when this item is clicked
| deactivate : (`Ext.menu.BaseItem this`) | BaseItem
Fires when this item is deactivated
| destroy : (`Ext.Component this`) | Component
Fires after the component is destroyed
| disable : (`Ext.Component this`) | Component
Fires after the component is disabled
| enable : (`Ext.Component this`) | Component
Fires after the component is enabled
| hide : (`Ext.Component this`) | Component
Fires after the component is hidden
| render : (`Ext.Component this`) | Component
Fires after the component is rendered
| show : (`Ext.Component this`) | Component
Fires after the component is shown

## Config Options

Config Options | Defined By
--- | ---
| activeClass : String | BaseItem
The CSS class to use when the item becomes activated (defaults to "x-menu-item-active")
| canActivate : Boolean | BaseItem
True if this item can be visually activated (defaults to false)
| handler : Function | BaseItem
A function that will handle the click event of this menu item (defaults to undefined)
| hideDelay : Number | BaseItem
Length of time in milliseconds to wait before hiding after a click (defaults to 100)
| hideOnClick : Boolean | BaseItem
True to hide the containing menu after this item is clicked (defaults to true)

## Property Details

### disabled

`public Object disabled`
true if this component is disabled. Read-only.
This property is defined by Component.

### disabledClass

`public Object disabledClass`
CSS class added to the component when it is disabled.
This property is defined by Component.

### hidden

`public Object hidden`
true if this component is hidden. Read-only.
This property is defined by Component.

### rendered

`public Object rendered`
true if this component has been rendered. Read-only.
This property is defined by Component.

## Constructor Details

### Adapter

`public function Adapter(`Object config`)`
Creates a new Adapter
Parameters:

- `config` : Object
  Configuration options

## Method Details

### addEvents

`public function addEvents(`Object object`)`
Copies any events from the passed object onto this object if they do not already exist. The passed object must also inherit from Observable for this method to have any effect.
Parameters:

- `object` : Object
  The object from which to copy events

Returns:

- `void`

This method is defined by Observable.

### addListener

`public function addListener(`String eventName`, `Function handler`, [`Object scope`], [`Object options`])`
Appends an event handler to this component
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The method the event invokes
- `scope` : Object
  (optional) The scope in which to execute the handler function. The handler function's "this" context.
- `options` : Object
  (optional) An object containing handler configuration properties. This may contain any of the following properties:
  - scope {Object} The scope in which to execute the handler function. The handler function's "this" context.
  - delegate {String} A simple selector to filter the target or look for a descendant of the target
  - stopEvent {Boolean} True to stop the event. That is stop propagation, and prevent the default action.
  - preventDefault {Boolean} True to prevent the default action
  - stopPropagation {Boolean} True to prevent event propagation
  - normalized {Boolean} False to pass a browser event to the handler function instead of an Ext.EventObject
  - delay {Number} The number of milliseconds to delay the invocation of the handler after te event fires.
  - single {Boolean} True to add a handler to handle just the next firing of the event, and then remove itself.
  - buffer {Number} Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.

  Combining Options
  Using the options argument, it is possible to combine different types of listeners:
  A normalized, delayed, one-time listener that auto stops the event and passes a custom argument (forumId)

  Code:

      el.on('click', this.onClick, this, { single: true, delay: 100, stopEvent : true, forumId: 4 });

  The method also allows for a single argument to be passed which is a config object containing properties which specify multiple handlers.

  Attaching multiple handlers in 1 call
  Code:

      el.on({ 'click' : { fn: this.onClick scope: this, delay: 100 }, 'mouseover' : { fn: this.onMouseOver scope: this }, 'mouseout' : { fn: this.onMouseOut scope: this } });

  Or a shorthand syntax:
  Code:

      el.on({ 'click' : this.onClick, 'mouseover' : this.onMouseOver, 'mouseout' : this.onMouseOut scope: this });

Returns:

- `void`

This method is defined by Observable.

### disable

`public function disable()`
Disable this component
Parameters:

- None.

Returns:

- `void`

This method is defined by Component.

### enable

`public function enable()`
Enable this component
Parameters:

- None.

Returns:

- `void`

This method is defined by Component.

### fireEvent

`public function fireEvent(`String eventName`, `Object... args`)`
Fires the specified event with the passed parameters (minus the event name).
Parameters:

- `eventName` : String
- `args` : Object...
  Variable number of parameters are passed to handlers

Returns:

- `Boolean`
  returns false if any of the handlers return false otherwise it returns true

This method is defined by Observable.

### focus

`public function focus(`Boolean selectText`)`
Try to focus this component
Parameters:

- `selectText` : Boolean
  True to also select the text in this component (if applicable)

Returns:

- `void`

This method is defined by Component.

### getEl

`public function getEl()`
Returns the underlying Ext.Element
Parameters:

- None.

Returns:

- `Ext.Element`
  The element

This method is defined by Component.

### getId

`public function getId()`
Returns the id of this component
Parameters:

- None.

Returns:

- `String`

This method is defined by Component.

### hasListener

`public function hasListener(`String eventName`)`
Checks to see if this object is currently listening for a specified event
Parameters:

- `eventName` : String
  The name of the event to check for

Returns:

- `Boolean`
  True if the event is being listened for, else false

This method is defined by Observable.

### hide

`public function hide()`
Hide this component
Parameters:

- None.

Returns:

- `void`

This method is defined by Component.

### isVisible

`public function isVisible()`
Returns true if this component is visible
Parameters:

- None.

Returns:

- `void`

This method is defined by Component.

### on

`public function on(`String eventName`, `Function handler`, [`Object options`])`
Appends an event handler to this element (shorthand for addListener)
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The method the event invokes
- `options` : Object
  (optional)

Returns:

- `void`

This method is defined by Observable.

### purgeListeners

`public function purgeListeners()`
Removes all listeners for this object
Parameters:

- None.

Returns:

- `void`

This method is defined by Observable.

### removeListener

`public function removeListener(`String eventName`, `Function handler`, [`Object scope`])`
Removes a listener
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The handler to remove
- `scope` : Object
  (optional) The scope (this object) for the handler

Returns:

- `void`

This method is defined by Observable.

### render

`public function render([`String/HTMLElement/Element container`])`
If this is a lazy rendering component, render it to its container element
Parameters:

- `container` : String/HTMLElement/Element
  (optional) The element this component should be rendered into. If it is being applied to existing markup, this should be left off.

Returns:

- `void`

This method is defined by Component.

### setDisabled

`public function setDisabled(`Boolean disabled`)`
Convenience function for setting disabled/enabled by boolean
Parameters:

- `disabled` : Boolean

Returns:

- `void`

This method is defined by Component.

### setVisible

`public function setVisible(`Boolean visible`)`
Convenience function to hide or show this component by boolean
Parameters:

- `visible` : Boolean
  True to show, false to hide

Returns:

- `void`

This method is defined by Component.

### show

`public function show()`
Show this component
Parameters:

- None.

Returns:

- `void`

This method is defined by Component.

### un

`public function un(`String eventName`, `Function handler`, [`Object scope`])`
Removes a listener (shorthand for removeListener)
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The handler to remove
- `scope` : Object
  (optional) The scope (this object) for the handler

Returns:

- `void`

This method is defined by Observable.

## Event Details

### activate

`public event activate`
Fires when this item is activated
Subscribers will be called with the following parameters:

- `this` : Ext.menu.BaseItem

This event is defined by BaseItem.

### beforedestroy

`public event beforedestroy`
Fires before the component is destroyed
Subscribers will be called with the following parameters:

- `this` : Ext.Component

This event is defined by Component.

### beforehide

`public event beforehide`
Fires before the component is hidden
Subscribers will be called with the following parameters:

- `this` : Ext.Component

This event is defined by Component.

### beforerender

`public event beforerender`
Fires before the component is rendered
Subscribers will be called with the following parameters:

- `this` : Ext.Component

This event is defined by Component.

### beforeshow

`public event beforeshow`
Fires before the component is shown
Subscribers will be called with the following parameters:

- `this` : Ext.Component

This event is defined by Component.

### click

`public event click`
Fires when this item is clicked
Subscribers will be called with the following parameters:

- `this` : Ext.menu.BaseItem
- `e` : Ext.EventObject

This event is defined by BaseItem.

### deactivate

`public event deactivate`
Fires when this item is deactivated
Subscribers will be called with the following parameters:

- `this` : Ext.menu.BaseItem

This event is defined by BaseItem.

### destroy

`public event destroy`
Fires after the component is destroyed
Subscribers will be called with the following parameters:

- `this` : Ext.Component

This event is defined by Component.

### disable

`public event disable`
Fires after the component is disabled
Subscribers will be called with the following parameters:

- `this` : Ext.Component

This event is defined by Component.

### enable

`public event enable`
Fires after the component is enabled
Subscribers will be called with the following parameters:

- `this` : Ext.Component

This event is defined by Component.

### hide

`public event hide`
Fires after the component is hidden
Subscribers will be called with the following parameters:

- `this` : Ext.Component

This event is defined by Component.

### render

`public event render`
Fires after the component is rendered
Subscribers will be called with the following parameters:

- `this` : Ext.Component

This event is defined by Component.

### show

`public event show`
Fires after the component is shown
Subscribers will be called with the following parameters:

- `this` : Ext.Component

This event is defined by Component.

## Config Details

### activeClass

`activeClass : String`
The CSS class to use when the item becomes activated (defaults to "x-menu-item-active")
This config option is defined by BaseItem.

### canActivate

`canActivate : Boolean`
True if this item can be visually activated (defaults to false)
This config option is defined by BaseItem.

### handler

`handler : Function`
A function that will handle the click event of this menu item (defaults to undefined)
This config option is defined by BaseItem.

### hideDelay

`hideDelay : Number`
Length of time in milliseconds to wait before hiding after a click (defaults to 100)
This config option is defined by BaseItem.

### hideOnClick

`hideOnClick : Boolean`
True to hide the containing menu after this item is clicked (defaults to true)
This config option is defined by BaseItem.

Ext - Copyright © 2006-2007 Ext JS, LLC
All rights reserved.